package tp4509.tcp;

import static dm4509.common.Log.COMM;
import static dm4509.common.Log.LOGGER_NAME_COMM;
import static dm4509.common.Log.LOGGER_NAME_GEN;
import static dm4509.common.Log.LOG_ON;


import java.nio.channels.SocketChannel;

import org.apache.log4j.Level;

import dm4509.common.Log;
import tp4509.picross.PicrossApi;
/**
 * Code du thread qui impémente de protocole du client.
 * @author Eric Lallet.
 *
 */
public class ThreadClient implements Runnable {
	/**
	 * Le canal connecté au serveur.
	 */
	private SocketChannel rwChan;
	/**
	 * référence vers la classe qui gère les données du jeu.
	 */
	private  PicrossApi picrossApi;

	/**
	 * Constructeur qui initalise les attributs de la classe.
	 * @param rwChan
	 *        Le canal connecté au serveur.
	 * @param picrossApi
	 *        référence vers la classe qui gère les données du jeu.
	 */
	public ThreadClient(final SocketChannel rwChan, final PicrossApi picrossApi) {
		// picross en réseau.
		Log.configureALogger(LOGGER_NAME_COMM, Level.INFO);
		Log.configureALogger(LOGGER_NAME_GEN, Level.INFO);
		this.rwChan = rwChan;
		this.picrossApi = picrossApi;


	}

	@Override
	public void run() {
		// TODO Question 3.3.3
	}



	/**
	 * Lit une trame complète du  protocole et retourne le message construit à partir de cette trame.
	 * Méthode à utiliser en mode synchrone (bloquant). Elle se termine si l'un des trois cas suivants arrive:
	 *   1. le buffer est plein (le cas normal);
	 *   2. la connexion est fermée;
	 *   3. une exception se produit.
	 * @return
	 *        le message construit à partir de la trame reçus, ou null si connexion est fermée ou
	 *        si une execption se produit durant la réception.   
	 */
	public  MessageProtocole recevoirMessage() {
		// TODO Question 3.3.2
		return null;
	}

	/**
	 * Notifie picrossApi que l'initialisation des hauteurs et largeurs est terminée.
	 * Tant que cette initiatilisation n'est pas terminée, picrossApi bloque (wait()) sur les requêtes
	 * qui réclament ces valeurs.
	 */
	public void notifierFinInitialisation() {
		picrossApi.indiquerInitialisationFinie();

	}

}
